#include <iostream>
using namespace std;
void popuni(int x[][100],int m,int n,int i,int j){
    x[i][j]=2;
    if(i+1>0 && i+1<=m && j>0 && j<=n)
        popuni(x,m,n,i+1,j); 
    if(i-1>0 && i-1<=m && j>0 && j<=n)
        popuni(x,m,n,i-1,j);
    if(i>0 && i<=m && j-1>0 && j-1<=n)
        popuni(x,m,n,i,j-1);
    if(i>0 && i<=m && j+1>0 && j+1<=n)
        popuni(x,m,n,i,j+1);
}
int broj(int x[][100],int m,int n){
    int p=0;
    for(int i=1;i<=m;i++)
        for(int j=1;j<=n;j++)
            if(x[i][j]!=1 && x[i][j]!=2){
                p++;
                popuni(x,m,n,i,j);
            }
    return p;
}
int main()
{
    int m,n,k,a,b,s;
    cin>>m>>n>>k;
    int x[100][100];
    for(int i=1;i<=k;i++){
        cin>>a>>b;
        x[a][b]=1;
    }
    s=broj(x,m,n);
    return 0;
}